-- THE BG
application:setBackgroundColor(0x00aaee)

-- SOME VARIABLES
local myappwidth, myappheight = application:getContentWidth(), application:getContentHeight()

-- THE OBJs
local objground = loadObj("|R|", "ground.obj")
local objwell = loadObj("|R|", "well.coveredopen.obj")
local objcube = loadObj("|R|", "cube.obj")

-- THE OBJs DIMENSIONS
local wellminx, wellminy, wellminz, wellmaxx, wellmaxy, wellmaxz =
			objwell.min[1], objwell.min[2], objwell.min[3],
			objwell.max[1], objwell.max[2], objwell.max[3]
local wellcx, wellcy, wellcz =
			(wellminx + wellmaxx) / 2, (wellminy + wellmaxy) / 2, (wellminz + wellmaxz) / 2
local wellmx, wellmy, wellmz =
			wellmaxx - wellminx, wellmaxy - wellminy, wellmaxz - wellminz
print(wellminy, wellmaxy)
local cubeminx, cubeminy, cubeminz, cubemaxx, cubemaxy, cubemaxz =
			objcube.min[1], objcube.min[2], objcube.min[3],
			objcube.max[1], objcube.max[2], objcube.max[3]
local cubecx, cubecy, cubecz =
			(cubeminx + cubemaxx) / 2, (cubeminy + cubemaxy) / 2, (cubeminz + cubemaxz) / 2
local cubemx, cubemy, cubemz =
			cubemaxx - cubeminx, cubemaxy - cubeminy, cubemaxz - cubeminz
print(cubeminy, cubemaxy)

-- THE CAMERA POSITION
local myx, myy, myz, myrx, myry, myrz = -2, 1.78, 6, 0, 0, 0

-- THE VIEWPORT
local mysprite = Sprite.new()
local myviewport = Viewport.new()
local mymatrix = Matrix.new()
mymatrix:perspectiveProjection(30, -1, 1, 100)
myviewport:setProjection(mymatrix)
myviewport:setPosition(0, 0, 0)
myviewport:setScale(myappheight, myappwidth, 1)
myviewport:setContent(mysprite)
stage:addChild(myviewport)

-- THE LIGHT
local lx, ly, lz = myviewport:getTransform():transformPoint(1, 1, 1)
Lighting.setLight(lx, ly, lz, 0.5)
Lighting.setSpecular(0.3, 0.3, 0.3, 32)

-- 1 GROUND INSTANCE
local ground1 = Viewport.new()
ground1:setContent(objground)
ground1:setPosition(0, 0, -5)
mysprite:addChild(ground1)

-- 1 WELL INSTANCE
local well1 = Viewport.new()
well1:setContent(objwell)
well1:setPosition(2, objground.max[2] - wellminy, -5)
print(wellmy)
mysprite:addChild(well1)
Lighting.apply(objwell)

-- 1 CUBE INSTANCE
local cube1 = Viewport.new()
cube1:setContent(objcube)
cube1:setPosition(0, objground.max[2] - cubeminy, -5)
mysprite:addChild(cube1)
Lighting.apply(objcube)

-- SOME DEBUGGING
local mytext = TextField.new(nil, "XXX")
mytext:setScale(3)
stage:addChild(mytext)

-- THE GAME
local game = {}
game.keys = {}

function update()
	local x, y, z, rx, ry, rz = myx, myy, myz, myrx, myry, myrz -- rotation in degree
	if rx >= 30 then rx = 30 end
	if rx <= 0 then rx = 0 end
	if ry >= 30 then ry = 30 end
	if ry <= -30 then ry = -30 end

	mytext:setText("rx = "..rx.."\nry = "..ry.."\nrz = "..rz)

	if game.keys[KeyCode.UP] then
		x += math.sin(^< rx) * 0.05
		y = y
		z -= math.cos(^< rx) * 0.05
	end
	if game.keys[KeyCode.DOWN] then
		x -= math.sin(^< rx) * 0.05
		y = y
		z += math.cos(^< rx) * 0.05
	end
	if game.keys[KeyCode.LEFT] then
		x -= math.cos(^< rx) * 0.05
		y = y
		z += math.sin(^< rx) * 0.05
	end
	if game.keys[KeyCode.RIGHT] then
		x += math.cos(^< rx) * 0.05
		y = y
		z -= math.sin(^< rx) * 0.05
	end
	if game.keys[KeyCode.J] then	  
		ry += 0.5
	end
	if game.keys[KeyCode.L] then
		ry -= 0.5
	end
	if game.keys[KeyCode.I] then	  
		rx += 0.5
	end
	if game.keys[KeyCode.K] then
		rx -= 0.5
	end

	myviewport:lookAngles(myx, myy, myz, myrx, myry, myrz)
	myx, myy, myz, myrx, myry, myrz = x, y, z, rx, ry, rz
end

function keyUp(event)
	local key, rc = event.keyCode, event.realCode
	game.keys[key] = false
	game.keys[rc] = false
end

function keyDown(event)
	local key, rc = event.keyCode, event.realCode
	game.keys[key] = true
	game.keys[rc] = true
end

stage:addEventListener(Event.ENTER_FRAME,update)
stage:addEventListener(Event.KEY_DOWN,keyDown)
stage:addEventListener(Event.KEY_UP,keyUp)
